<script setup lang="ts">
import BootstrapModal from "@/components/modals/BootstrapModal.vue";
import { computed, onMounted, reactive, ref, watch } from "vue";
import { Modal, Toast } from "bootstrap";
import { partial } from "filesize";
import { useS3ObjectStore } from "@/stores/s3objects";
import BootstrapToast from "@/components/BootstrapToast.vue";
import type { AbortController } from "@smithy/types";

const fsize = partial({ base: 2, standard: "jedec" });
const objectRepository = useS3ObjectStore();

const props = defineProps<{
  modalId: string;
  bucketName: string;
  keyPrefix: string;
  editObjectFileName?: string;
}>();

const randomIDSuffix = Math.random().toString(16).substring(2, 8);
const objectFileInput = ref<HTMLInputElement | undefined>(undefined);
let uploadModal: Modal | null = null;
let successToast: Toast | null = null;
let errorToast: Toast | null = null;

const currentFolders = computed<string[]>(() => props.keyPrefix.split("/"));

watch(
  () => props.editObjectFileName,
  (nextFileName) => {
    formState.key = nextFileName ?? "";
  },
);

const formState = reactive<{
  file?: File;
  key: string;
  uploading: boolean;
  uploadDone: number;
  uploadTotal: number;
  err: string;
  abortController?: AbortController;
}>({
  file: undefined,
  key: "",
  uploading: false,
  uploadDone: 0,
  uploadTotal: 1,
  err: "",
  abortController: undefined,
});

const uploadProgress = computed<number>(() =>
  Math.round((100 * formState.uploadDone) / formState.uploadTotal),
);

const editObject = computed<boolean>(
  () => props.editObjectFileName !== undefined,
);

function uploadObject() {
  if (formState.file == undefined) {
    return;
  }
  const key =
    props.keyPrefix.length > 0
      ? props.keyPrefix + "/" + formState.key
      : formState.key;
  formState.uploadDone = 0;
  formState.uploading = true;
  formState.abortController = new AbortController();
  formState.uploadTotal = formState.file.size;
  objectRepository
    .uploadObjectFile(
      props.bucketName,
      key,
      formState.file,
      (progress) => {
        if (progress.loaded != null) {
          formState.uploadDone = progress.loaded;
        }
        if (progress.total != null) {
          formState.uploadTotal = progress.total;
        }
      },
      formState.abortController,
    )
    .then(() => {
      uploadModal?.hide();
      successToast?.show();
      formState.key = "";
      if (objectFileInput.value != undefined) {
        objectFileInput.value.value = "";
      }
    })
    .catch((e) => {
      formState.err = e.name;
      errorToast?.show();
    })
    .finally(() => {
      formState.uploading = false;
      formState.abortController = undefined;
    });
}

function fileChange() {
  if (objectFileInput.value != undefined) {
    // eslint-disable-next-line @typescript-eslint/no-non-null-assertion
    formState.file = objectFileInput.value.files![0];
    if (!editObject.value) {
      formState.key = formState.file.name;
    }
  }
}

onMounted(() => {
  uploadModal = new Modal("#" + props.modalId);
  successToast = new Toast("#successToast-" + randomIDSuffix);
  errorToast = new Toast("#errorToast-" + randomIDSuffix);
});
</script>

<template>
  <bootstrap-toast :toast-id="'successToast-' + randomIDSuffix">
    Successfully uploaded file
  </bootstrap-toast>
  <bootstrap-toast
    :toast-id="'errorToast-' + randomIDSuffix"
    color-class="danger"
  >
    There has been some Error.<br />
    Code: {{ formState.err }}
  </bootstrap-toast>
  <bootstrap-modal
    :modal-id="modalId"
    :static-backdrop="true"
    modal-label="Upload Object Modal"
    :track-modal-value="
      bucketName + (keyPrefix.length > 0 ? '/' + keyPrefix : '')
    "
  >
    <template #header>
      <h4>Upload file to</h4>
      <ol class="breadcrumb">
        <li class="breadcrumb-item">{{ props.bucketName }}</li>
        <li
          class="breadcrumb-item"
          v-for="folder in currentFolders"
          :key="folder"
        >
          {{ folder }}
        </li>
      </ol>
    </template>
    <template #body>
      <div class="container-fluid">
        <p>{{ formState.err }}</p>
        <div class="row">
          <form
            class="col-7"
            :id="'uploadObjectForm' + randomIDSuffix"
            @submit.prevent="uploadObject"
          >
            <div class="mb-3">
              <label
                :for="'objectFile' + randomIDSuffix"
                class="form-label"
                v-if="editObject"
              >
                New File Content *
              </label>
              <label
                :for="'objectFile' + randomIDSuffix"
                class="form-label"
                v-else
              >
                File *
              </label>
              <input
                class="form-control"
                type="file"
                :id="'objectFile' + randomIDSuffix"
                ref="objectFileInput"
                required
                @change="fileChange"
              />
            </div>
            <div class="mb-3">
              <label :for="'objectKey' + randomIDSuffix" class="form-label"
                >Filename</label
              >
              <input
                type="text"
                :class="{
                  'form-control-plaintext': editObject,
                  'form-control': !editObject,
                }"
                :id="'objectKey' + randomIDSuffix"
                required
                :disabled="editObject"
                v-model="formState.key"
              />
            </div>
          </form>
          <div class="col-5">
            Note: Delimiters ('/') are allowed in the file name to place the new
            file into a folder that will be created when the file is uploaded
            (to any depth of folders).
          </div>
        </div>
      </div>
    </template>
    <template v-slot:footer>
      <div class="w-50 me-auto" v-if="formState.uploading">
        <div
          class="progress"
          aria-valuemin="0"
          aria-valuemax="100"
          role="progressbar"
          :aria-valuenow="uploadProgress"
          aria-label="Upload Progressbar"
        >
          <div
            class="progress-bar bg-info"
            :style="{ width: uploadProgress + '%' }"
          >
            {{ uploadProgress }}%
          </div>
        </div>
        <span>
          {{ fsize(formState.uploadDone) }} /
          {{ fsize(formState.uploadTotal) }}
        </span>
      </div>
      <button type="button" class="btn btn-secondary" data-bs-dismiss="modal">
        Close
      </button>
      <button
        v-if="formState.uploading"
        type="button"
        class="btn btn-danger"
        @click="formState.abortController?.abort()"
      >
        Cancel
      </button>
      <button
        v-else
        type="submit"
        :form="'uploadObjectForm' + randomIDSuffix"
        class="btn btn-primary"
      >
        Upload
      </button>
    </template>
  </bootstrap-modal>
</template>

<style scoped></style>
